{$R+}
Program h; uses dos;
{Snqtie spektra zwuka iz *.wav;
  w nast. moment ras`. tk. na monofoni`. dwuhbajtn. zapisx 
  s ukazann. parametrami; velatelxno dodel., `toby opr. param. samo
  i obrabatywalo i dr. slu`ai (sm. anal_wav.pas).
 Teku]. sost.: popytalisx izbevatx propavi to`ek za s`@t zatiraniq;
  dlq odino`nogo spektra - wrode polu`.; wozm. zatiranie sledu;]im spektrom -
  wrode neobh. borotxsq s \tim net, realxnye wspy[ki not dlitelxny.
}
{Neqsno: wrode na stadii zwu`aniq inogda w furxe-spektre - -const, kak ot 
  delta-f-cii; velat. proweritx.
}

{~elowek wblizi 400 Gz razli`aet poluton, no uve ne razl. ~1/5 polutona;
 t.e. 2^/(1/12) - razli`., 2^(1/60) - uve net;
 x=2^(1/60) => ln(x) = 1/60 * ln(2) ~= 0.6/60 ~= 0.01 => x ~= 1.01;
 dlq opr. tona s takoj to`n. treb. 1/0.01 = 100 periodow;
 dlq 400 Gz \to (1/400)*100 ~= 1/4 sekundy.
  Napr., dlq 44100 to`ek/sek treb.by ~10000 to`ek.
  Wozxm@m, napr., 8192 ili dave 4096. Obozn. \to `islo n1.
  Furxe-spektr: my ber@m n1 ots`@tow; dwSamplesPerSec = 1 sek;
  wremq zwu`. analizir. posl-sti = t0 = n1/dwSamplesPerSec sek.
  Maks. `astota: kogda (+1 -1)n, ukladyw. n1/2 periodow =>
  1 period = 2/dwSamplesPerSec => maks. `astota = dwSamplesPerSec/2.
  ~islo to`ek v spektre ns=(np div 2)+1 (dalee - dlq teh ve `astot sin i cos);
  t.e. `astota dlq \l-ta x[i] posle fft = ((i-1)/ns)*(dwSamplesPerSec/2).
}

 {$i uses_gra.pas}
 {$i bunko.pas}

 var e1,e2:ekr;
 var b1:bunko;

 const {2^m1 = n1}
   {n1=64; m1=6;}
   {n1=128; m1=7;}
   {n1=256; m1=8;}
   {n1=512; m1=9;}
   {n1=1024; m1=10;}
   {n1=2048; m1=11;}
   {n1=4096; m1=12;}
   n1=8192; m1=13;
 const ns=(n1 div 2)+1; {chislo tochek v spektre}

 type mass=array[1..n1] of real;
 {$i fft_old.pas}

 var b:file of integer;
 var dwSamplesPerSec,nSamples,p:longint;
 var t,t_max:real;

 var w0:integer; w:array[1..n1] of integer;
 var x,y:^mass;

 procedure opr_param;
 begin
  dwSamplesPerSec:=44100;
  nSamples:=352800;
  t_max:=8.0;
  p:=$2C div 2; {t.k. file of word}
 end;

 procedure w_x; var i:integer;
 begin
  for i:=1 to n1 do begin x^[i]:=w[i]*(i/n1); y^[i]:=0; end;
 end;

 procedure show_furxe;
  var i,color:integer; s,ny,rcolor,porog,xmax:real;
  var bb:text;
  const dinam_diap=15;
  const revim=1{2};
  var ind:integer; imax:integer; fmax:real;
 begin
  initio(b1,e2.iy0-e2.iy1+1);
  {ns:=(n1 div 2)+1;} {chislo tochek v spektre}
  for i:=1 to n1 do begin x^[i]:=sqrt(sqr(x^[i])+sqr(y^[i])); y^[i]:=0; end;
  for i:=2 to ns-1 do begin x^[i]:=x^[i]+x^[n1+2-i]; x^[n1+2-i]:=0; end;
  {i=1 sootv.post.sost. - yeyo isklyuch.}
  s:=0; xmax:=0; for i:=2 to ns do begin
   s:=s+x^[i];
   if x^[i]>xmax then xmax:=x^[i];
  end;
  porog:=s/ns; porog:={porog*20.0}5e5;
  {assign(bb,'otlad3.lst'); rewrite(bb);}
  for i:=2 to ns do begin
   ny:=((i-1)/ns)*(dwSamplesPerSec/2);
   if revim=1 then begin
    rcolor:=getmaxcolor*(x^[i]/porog);
   end else begin
    x^[i]:=ln(x^[i]/xmax)/ln(2);
    rcolor:=(getmaxcolor/dinam_diap)*(x^[i]+dinam_diap);
    rcolor:=rcolor*2; {silnye linii pustx za[kalqt}
   end;

   ind:=y2j(ln(ny)/ln(2),e2)-e2.iy1+1;
   if rcolor>b1.a[ind] then b1.a[ind]:=rcolor;

   {writeln(bb,i:5,' ',ny:10:4,' ',ln(ny)/ln(2):10:4,' ',x^[i]:12:6,' ',color);}
  end {i:=2 to ns};
  {for i:=1 to b1.n do if b1.a[i]<>-1 then writeln('b1.a[]: ',i:4,' ',b1.a[i]:12:6);}
  zapoln(b1,imax,fmax); {writeln(imax:5,' ',fmax:12:6);}
  fmax:=100.0;
  for i:=1 to b1.n do begin
   ind:=i-1+e2.iy1;
   rcolor:=getmaxcolor*(b1.a[i]/fmax);
   rcolor:=rcolor*10;
   if rcolor<0 then rcolor:=0; if rcolor>getmaxcolor then rcolor:=getmaxcolor;
   color:=round(rcolor);
   putpixel(x2i(t,e2),ind,color);
   {writeln(bb,i:4,' ',b1.a[i]:12:6,' ',x2i(t,e2):5,ind:5,color:5);}
  end;
  {close(bb);}
 end;

 var i:integer; ico:longint; ny:real;

Begin
 new(x); new(y);
 opr_param;
 assign(b,'test4a.wav'); reset(b);
 seek(b,p); read(b,w0); seek(b,p);
 for i:=1 to n1 do w[i]:={w0}0;

 initgraph_12; b_w_12;
 prisv_ekr(e1, 0,x_y,0,0.2, 0,t_max,-3e3,3e3,-1,1,-1,1);
 prisv_ramk(e1,8,4,1,1); ramka(e1);
 prisv_ekr(e2, 0,x_y,0.2,1, 0,t_max,ln(100)/ln(2),ln(3200)/ln(2),-1,1,-1,1);
 prisv_ramk(e2,8,5,1,12); ramka(e2);

 ico:=-1; while not eof(b) do begin
  for i:=1 to n1-1 do w[i]:=w[i+1];
  read(b,w[n1]); w[n1]:=w[n1]-w0;
  inc(ico);
  t:=ico/dwSamplesPerSec;
  po(t,w[n1],e1,15);
  {if ico mod 1000=1 then writeln(ico:8,' ',t:10:4,' ',w[n1]:6);}
  if ico mod 500=1 {(ico=20000) or (ico=50000) or (ico=50100)} then begin
   w_x;
   fft(x^,y^,n1,m1,true);
   for i:=2 to {ns}100 do begin
    ny:=((i-1)/ns)*(dwSamplesPerSec/2);
    {writeln('pered',i:4,' ',ny:10:4,' ',ln(ny)/ln(2):10:4,' ',x^[i]:12:6,' ',y^[i]:12:6);}
   end;
   show_furxe;
   for i:=2 to {ns}100 do begin
    ny:=((i-1)/ns)*(dwSamplesPerSec/2);
    {writeln('posle',i:4,' ',ny:10:4,' ',ln(ny)/ln(2):10:4,' ',x^[i]:12:6,' ',y^[i]:12:6);}
   end;
   {writeln('--------');}
 end;
 end;
 ramka(e2);

 dispose(y); dispose(x);
 close(b);
 readln; closegraph;
End.
